/* lambda4.c -- EPM */

#include "tools.h"
#include "sos.h"
#include "depths.h"

depth_counters (Lambda4, 15);

/*--------------------------------------------------------------------------*/

INT SignLambda4 (Ai, Bi, Ci,
                 Aj, Bj, Cj,
                 Ak, Bk, Ck,
                 Al, Bl, Cl)
IN LIA
  Ai[], Bi[], Ci[],
  Aj[], Bj[], Cj[], 
  Ak[], Bk[], Ck[], 
  Al[], Bl[], Cl[];
/* computes sign of epsilon determinant Lambda4; generated with gendela
   NOTE: needs modules deter & signdet_one */
{
  the_beginning;
#ifdef EBUG
  if (SoS_proto_e)
    {
      lia_reset ();
      print ("Lambda4 (%s,%s,%s,one;",
                                lia_deci (Ai), lia_deci (Bi), lia_deci (Ci));
      print ("%s,%s,%s,one;",   lia_deci (Aj), lia_deci (Bj), lia_deci (Cj));
      print ("%s,%s,%s,one;",   lia_deci (Ak), lia_deci (Bk), lia_deci (Ck));
      print ("%s,%s,%s,one)\n", lia_deci (Al), lia_deci (Bl), lia_deci (Cl));
    }
#endif
  /* c code generated by program gendela */
  check;  s =   SignDet4one (Ai,Bi,Ci, Aj,Bj,Cj, Ak,Bk,Ck, Al,Bl,Cl);
  check;  s =   SignDet3one (Aj,Bj, Ak,Bk, Al,Bl);
  check;  s = - SignDet3one (Aj,Cj, Ak,Ck, Al,Cl);
  check;  s =   SignDet3one (Bj,Cj, Bk,Ck, Bl,Cl);
  check;  s = - SignDet3one (Ai,Bi, Ak,Bk, Al,Bl);
  check;  s =   SignDet2one (Ak, Al);
  check;  s = - SignDet2one (Bk, Bl);
  check;  s =   SignDet3one (Ai,Ci, Ak,Ck, Al,Cl);
  check;  s =   SignDet2one (Ck, Cl);
  check;  s = - SignDet3one (Bi,Ci, Bk,Ck, Bl,Cl);
  check;  s =   SignDet3one (Ai,Bi, Aj,Bj, Al,Bl);
  check;  s = - SignDet2one (Aj, Al);
  check;  s =   SignDet2one (Bj, Bl);
  check;  s =   SignDet2one (Ai, Al);
  check;  s =   SignDet1one ();
  the_end;
}
